Convert
Eina » Tools

These functions allow you to convert integer or real numbers to string or conversely. More...

## Functions

EINA_API int | eina_convert_itoa (int n, char *s)
| Converts an integer number to a string in decimal base.
EINA_API int | eina_convert_xtoa (unsigned int n, char *s)
| Converts an integer number to a string in hexadecimal base.
EINA_API int | eina_convert_dtoa (double d, char *des)
| Converts a double to a string.
EINA_API Eina_Bool | eina_convert_atod (const char *src, int length, long long *m, long *e)
| Converts a string to a double.
EINA_API int | eina_convert_fptoa (Eina_F32p32 fp, char *des)
| Converts a 32.32 fixed point number to a string.
EINA_API Eina_Bool | eina_convert_atofp (const char *src, int length, Eina_F32p32 *fp)
| Converts a string to a 32.32 fixed point number.
EINA_API double | eina_convert_strtod_c (const char *nptr, char **endptr)
| Converts a string to a floating point number.

## Variables

EINA_API Eina_Error | EINA_ERROR_CONVERT_P_NOT_FOUND
| Not used, perhaps a placeholder?
EINA_API Eina_Error | EINA_ERROR_CONVERT_0X_NOT_FOUND
| Not used, perhaps a placeholder?
EINA_API Eina_Error | EINA_ERROR_CONVERT_OUTRUN_STRING_LENGTH
| Not used, perhaps a placeholder?

## Detailed Description

These functions allow you to convert integer or real numbers to string or conversely.

To use these functions, you have to call eina_init() first, and eina_shutdown() when eina is not used anymore.

# Conversion from integer to string

To convert an integer to a string in the decimal base, eina_convert_itoa() should be used. If the hexadecimal base is wanted, eina_convert_xtoa() should be used. They all need a buffer sufficiently large to store all the cyphers.

Here is an example of use:

#include <stdlib.h>
#include <stdio.h>
#include <Eina.h>
int main(void)
{
char tmp[128];
if (!eina_init())
{
printf ("Error during the initialization of eina.\n");
return EXIT_FAILURE;
}
eina_convert_itoa(45, tmp);
printf("value: %s\n", tmp);
eina_convert_xtoa(0xA1, tmp);
printf("value: %s\n", tmp);
eina_shutdown();
return EXIT_SUCCESS;
}
Eina.h
Eina Utility library.
eina_convert_itoa
EINA_API int eina_convert_itoa(int n, char *s)
Converts an integer number to a string in decimal base.
Definition eina_convert.c:154
eina_convert_xtoa
EINA_API int eina_convert_xtoa(unsigned int n, char *s)
Converts an integer number to a string in hexadecimal base.
Definition eina_convert.c:179
eina_shutdown
EINA_API int eina_shutdown(void)
Shuts down the Eina library.
Definition eina_main.c:379
eina_init
EINA_API int eina_init(void)
Initializes the Eina library.
Definition eina_main.c:291

Compile this code with the following command:

gcc -Wall -o test_eina_convert test_eina.c `pkg-config --cflags --libs eina`

Note
  The alphabetical cyphers are in lower case.

# Conversion double / string

To convert a double to a string, eina_convert_dtoa() should be used. Like with the integer functions, a buffer must be used. The resulting string has the following format (which is the result obtained with snprintf() and the %a modifier):

[-]0xh.hhhhhp[+-]e

To convert a string to a double, eina_convert_atod() should be used. The format of the string must be as above. Then, the double has the following mantissas and exponent:

mantissa : [-]hhhhhh
exponent : 2^([+-]e - 4 * n)

with n being number of cyphers after the point in the string format. To obtain the double number from the mantissas and exponent, use ldexp().

Here is an example of use:

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <Eina.h>
int main(void)
{
char tmp[128];
long long int m = 0;
long int e = 0;
double r;
if (!eina_init())
{
printf ("Error during the initialization of eina.\n");
return EXIT_FAILURE;
}
printf("initial value : 40.56\n");
eina_convert_dtoa(40.56, tmp);
printf("result dtoa : %s\n", tmp);
eina_convert_atod(tmp, 128, &m, &e);
r = ldexp((double)m, e);
printf("result atod : %f\n", r);
eina_shutdown();
return EXIT_SUCCESS;
}
eina_convert_dtoa
EINA_API int eina_convert_dtoa(double d, char *des)
Converts a double to a string.
Definition eina_convert.c:290
eina_convert_atod
EINA_API Eina_Bool eina_convert_atod(const char *src, int length, long long *m, long *e)
Converts a string to a double.
Definition eina_convert.c:198

Compile this code with the following command:

gcc -Wall -o test_eina_convert test_eina.c `pkg-config --cflags --libs eina` -lm

## Function Documentation

## eina_convert_itoa()

EINA_API int eina_convert_itoa | ( | int | n,
|  | char * | s )

Converts an integer number to a string in decimal base.

Parameters

  [in] | n | The integer to convert.
  [out] | s | The buffer to store the converted integer.

Returns
  The length of the string, including the null terminated character.

This function converts `n` to a null terminated string. The converted string is in decimal base. As no check is done, `s` must be a buffer that is sufficiently large to store the integer.

The returned value is the length of the string, including the null terminated character.

References EINA_SAFETY_ON_NULL_RETURN_VAL.

Referenced by eet_node_dump(), eina_convert_dtoa(), eina_convert_fptoa(), and eina_xattr_int_set().

## eina_convert_xtoa()

EINA_API int eina_convert_xtoa | ( | unsigned int | n,
|  | char * | s )

Converts an integer number to a string in hexadecimal base.

Parameters

  [in] | n | The integer to convert.
  [out] | s | The buffer to store the converted integer.

Returns
  The length of the string, including the null terminated character.

This function converts `n` to a null terminated string. The converted string is in hexadecimal base and the alphabetical cyphers are in lower case. As no check is done, `s` must be a buffer that is sufficiently large to store the integer.

The returned value is the length of the string, including the nul terminated character.

References EINA_SAFETY_ON_NULL_RETURN_VAL.

## eina_convert_dtoa()

EINA_API int eina_convert_dtoa | ( | double | d,
|  | char * | des )

Converts a double to a string.

Parameters

  [in] | d | The double to convert.
  [out] | des | The destination buffer to store the converted double.

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

This function converts the double `d` to a string. The string is stored in the buffer pointed by `des` and must be sufficiently large to contain the converted double. The returned string is null terminated and has the following format:

[-]0xh.hhhhhp[+-]e

where the h are the hexadecimal cyphers of the mantissas and e the exponent (a decimal number).

The returned value is the length of the string, including the null character.

References eina_convert_itoa(), EINA_SAFETY_ON_FALSE_RETURN_VAL, and EINA_SAFETY_ON_NULL_RETURN_VAL.

Referenced by eina_xattr_double_set().

## eina_convert_atod()

EINA_API Eina_Bool eina_convert_atod | ( | const char * | src,
|  | int | length,
|  | long long * | m,
|  | long * | e )

Converts a string to a double.

Parameters

  [in] | src | The string to convert.
  [in] | length | The length of the string.
  [out] | m | The mantissa.
  [out] | e | The exponent.

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

This function converts the string `s` of length `length` that represent a double in hexadecimal base to a double. It is used to replace the use of snprintf() with the %a modifier, which is missing on some platform (like Windows (tm) or OpenBSD).

The string must have the following format:

[-]0xh.hhhhhp[+-]e

where the h are the hexadecimal cyphers of the mantissas and e the exponent (a decimal number). If n is the number of cyphers after the point, the returned mantissas and exponents are:

mantissa : [-]hhhhhh
exponent : 2^([+-]e - 4 * n)

The mantissas and exponent are stored in the buffers pointed respectively by `m` and `e`.

If the string is invalid EINA_FALSE is returned, otherwise EINA_TRUE is returned.

References DBG, EINA_FALSE, EINA_SAFETY_ON_NULL_RETURN_VAL, and EINA_TRUE.

Referenced by eina_convert_atofp(), and eina_xattr_double_get().

## eina_convert_fptoa()

EINA_API int eina_convert_fptoa | ( | Eina_F32p32 | fp,
|  | char * | des )

Converts a 32.32 fixed point number to a string.

Parameters

  [in] | fp | The fixed point number to convert.
  [out] | des | The destination buffer to store the converted fixed point number.

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

This function converts the 32.32 fixed point number `fp` to a string. The string is stored in the buffer pointed by `des` and must be sufficiently large to contain the converted fixed point number. The returned string is terminated and has the following format:

[-]0xh.hhhhhp[+-]e

where the h are the hexadecimal cyphers of the mantissas and e the exponent (a decimal number).

The returned value is the length of the string, including the null character.

Note
  The code is the same than eina_convert_dtoa() except that it implements the frexp() function for fixed point numbers and does some optimization.

References eina_convert_itoa(), EINA_FALSE, and EINA_SAFETY_ON_NULL_RETURN_VAL.

## eina_convert_atofp()

EINA_API Eina_Bool eina_convert_atofp | ( | const char * | src,
|  | int | length,
|  | Eina_F32p32 * | fp )

Converts a string to a 32.32 fixed point number.

Parameters

  [in] | src | The string to convert.
  [in] | length | The length of the string.
  [out] | fp | The fixed point number.

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

This function converts the string `src` of length `length` that represent a double in hexadecimal base to a 32.32 fixed point number stored in `fp`. The function always tries to convert the string with eina_convert_atod().

The string must have the following format:

[-]0xh.hhhhhp[+-]e

where the h's are the hexadecimal cyphers of the mantissas and e the exponent (a decimal number). If n is the number of cyphers after the point, the returned mantissas and exponents are:

mantissa : [-]hhhhhh
exponent : 2^([+-]e - 4 * n)

The mantissas and exponent are stored in the buffers pointed respectively by `m` and `e`.

If the string is invalid, EINA_FALSE is returned, otherwise `fp` is computed and EINA_TRUE is returned.

Note
  The code uses eina_convert_atod() and do the correct bit shift to compute the fixed point number.

References eina_convert_atod(), EINA_FALSE, and EINA_TRUE.

## eina_convert_strtod_c()

EINA_API double eina_convert_strtod_c | ( | const char * | nptr,
|  | char ** | endptr )

Converts a string to a floating point number.

Parameters

  [in] | nptr | a string to convert. It shouldn't be NULL.
  [out] | endptr | If `endptr` is not NULL, a pointer to the character after the last character used in the conversion is stored in the location referenced by endptr. If `nptr` is NULL, this will also be set to NULL.

Returns
  a double type floating point number.

This function returns converted floating point number with locale-independency. Actually, it use "C" locale for strtod_l function internally. If you need strtod without locale-dependency, this function can replace strtod. For more information, please refer documents of strtod, strtod_l.

References EINA_SAFETY_ON_NULL_RETURN_VAL.

## Variable Documentation

## EINA_ERROR_CONVERT_P_NOT_FOUND

EINA_API Eina_Error EINA_ERROR_CONVERT_P_NOT_FOUND

extern

Not used, perhaps a placeholder?

Defined as 0 in eina_convert.c

## EINA_ERROR_CONVERT_0X_NOT_FOUND

EINA_API Eina_Error EINA_ERROR_CONVERT_0X_NOT_FOUND

extern

Not used, perhaps a placeholder?

Defined as 0 in eina_convert.c

## EINA_ERROR_CONVERT_OUTRUN_STRING_LENGTH

EINA_API Eina_Error EINA_ERROR_CONVERT_OUTRUN_STRING_LENGTH

extern

Not used, perhaps a placeholder?

Defined as 0 in eina_convert.c